From abd289f87f0b77a0d73d7fbd9884d71de7ed19b5 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Thu, 2 Feb 2012 15:25:25 -0600
Subject: Scaffold quick edit screen, check for validity.

---
 grade/report/quick_edit/classes/lib.php            |    4 +++
 grade/report/quick_edit/index.php                  |    6 ++++-
 .../quick_edit/lang/en/gradereport_quick_edit.php  |    3 ++
 grade/report/quick_edit/lib.php                    |   21 ++++++++++++++++++++
 grade/report/quick_edit/screens/grade/lib.php      |    4 +++
 grade/report/quick_edit/screens/user/lib.php       |    4 +++
 6 files changed, 41 insertions(+), 1 deletions(-)
 create mode 100644 grade/report/quick_edit/classes/lib.php
 create mode 100644 grade/report/quick_edit/screens/grade/lib.php
 create mode 100644 grade/report/quick_edit/screens/user/lib.php

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
new file mode 100644
index 0000000..beaed35
--- /dev/null
+++ b/grade/report/quick_edit/classes/lib.php
@@ -0,0 +1,4 @@
+<?php
+
+abstract class quit_edit_screen {
+}
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index c943128..47e73fe 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -43,6 +43,10 @@ if (!$course = $DB->get_record('course', array('id' => $courseid))) {
     print_error('nocourseid');
 }
 
+if (!in_array($itemtype, grade_report_quick_edit::valid_types())) {
+    print_error('notvalid', 'gradereport_quick_edit', '', $itemtype);
+}
+
 require_login($course);
 
 $context = get_context_instance(CONTEXT_COURSE, $course->id);
@@ -54,7 +58,7 @@ require_capability('moodle/grade:edit', $context);
 // End permission
 
 $_s = function($key, $a = null) {
-    return get_string($key, 'gradereport_quick_edit');
+    return get_string($key, 'gradereport_quick_edit', $a);
 };
 
 $gpr = new grade_plugin_return(array(
diff --git a/grade/report/quick_edit/lang/en/gradereport_quick_edit.php b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
index c000b2d..45361b2 100755
--- a/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
+++ b/grade/report/quick_edit/lang/en/gradereport_quick_edit.php
@@ -25,3 +25,6 @@
 // General Strings
 $string['pluginname'] = 'Quick Edit';
 $string['quick_edit:view'] = 'View the '.$string['pluginname'].' report';
+
+// Error Strings
+$string['notvalid'] = 'Not a valid Quick Edit screen: {$a}';
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index 8b05270..254b9f4 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -27,6 +27,27 @@ require_once($CFG->libdir.'/tablelib.php');
 
 class grade_report_quick_edit extends grade_report {
 
+    public static function valid_types() {
+        $screendir = dirname(__FILE__) . '/screens';
+
+        $is_valid = function($filename) use ($screendir) {
+            if (preg_match('/^\./', $filename)){
+                return false;
+            }
+
+            $file = $screendir . '/' . $filename;
+
+            if (is_file($file)) {
+                return false;
+            }
+
+            $plugin = $file . '/lib.php';
+            return file_exists($plugin);
+        };
+
+        return array_filter(scandir($screendir), $is_valid);
+    }
+
     function process_data($data) {
     }
 
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
new file mode 100644
index 0000000..976ae86
--- /dev/null
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -0,0 +1,4 @@
+<?php
+
+class quick_edit_grade extends quick_edit_screen {
+}
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
new file mode 100644
index 0000000..f954812
--- /dev/null
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -0,0 +1,4 @@
+<?php
+
+class quick_edit_user extends quick_edit_screen {
+}
-- 
1.7.1


